Bug 1169728 - GCC 10: qemu build fails
GCC 10: qemu build fails
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: Basesystem
Current
Other Other
: P5 - None : Normal (vote)
: ---
Assigned To: Martin Liška
E-mail List
:
Depends on:
Blocks: 1157217
  Show dependency treegraph
 
Reported: 2020-04-17 07:12 UTC by Martin Liška
Modified: 2020-05-26 17:05 UTC (History)
4 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---
pgnet.dev: needinfo? (martin.liska)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Liška 2020-04-17 07:12:35 UTC
Fails here:
https://build.opensuse.org/package/live_build_log/openSUSE:Factory:Staging:N/qemu/standard/x86_64

with:
[  150s] /home/abuild/rpmbuild/BUILD/qemu-4.2.0/scsi/qemu-pr-helper.c: In function 'multipath_pr_out':
[  150s] /home/abuild/rpmbuild/BUILD/qemu-4.2.0/scsi/qemu-pr-helper.c:523:32: error: array subscript <unknown> is outside array bounds of 'struct transportid *[]' [-Werror=array-bounds]
[  150s]   523 |             paramp.trnptid_list[paramp.num_transportid++] = id;
[  150s]       |             ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
[  150s] In file included from /home/abuild/rpmbuild/BUILD/qemu-4.2.0/scsi/qemu-pr-helper.c:36:
[  150s] /usr/include/mpath_persist.h:168:22: note: while referencing 'trnptid_list'
[  150s]   168 |  struct transportid *trnptid_list[];
[  150s]       |                      ^~~~~~~~~~~~
[  150s] /home/abuild/rpmbuild/BUILD/qemu-4.2.0/scsi/qemu-pr-helper.c:424:35: note: defined here 'paramp'
[  150s]   424 |     struct prout_param_descriptor paramp;
[  150s]       |                                   ^~~~~~


I first thought that it's GCC bug. But it seems it's correct warning:
https://gcc.gnu.org/bugzilla/show_bug.cgi?id=92326
Comment 2 Martin Liška 2020-04-17 07:28:31 UTC
Ah, all right, the patch is already included in devel project.
@Bruce: Can you please make a SR to Factory?
Comment 3 Bruce Rogers 2020-04-17 16:09:11 UTC
(In reply to Martin Liška from comment #2)
> Ah, all right, the patch is already included in devel project.
> @Bruce: Can you please make a SR to Factory?

Yes, I am planning for that shortly.
Comment 4 Bruce Rogers 2020-04-18 02:23:09 UTC
Fixed qemu is submitted to Factory.
Comment 5 Martin Liška 2020-04-21 13:16:59 UTC
There's one related issue in qemu:testsuite that I've just reported:

https://bugs.launchpad.net/qemu/+bug/1874073
Comment 6 Martin Liška 2020-04-21 13:26:28 UTC
I've just made a SR#796065.
Comment 7 Martin Liška 2020-04-23 05:08:38 UTC
Fixed in devel project.
Comment 8 Martin Liška 2020-04-24 09:28:43 UTC
Please push the package to openSUSE:Factory.
Comment 9 Swamp Workflow Management 2020-04-24 15:10:07 UTC
This is an autogenerated message for OBS integration:
This bug (1169728) was mentioned in
https://build.opensuse.org/request/show/797210 Factory / qemu
Comment 10 pgnd _ 2020-05-14 01:57:52 UTC
I build qemu @

  https://build.opensuse.org/project/show/home:pgnd:Virtualization:qemu

gcc9 has been working great.

after this bug's 'close', 

I switched my obs qemu build over to GCC 10.  One 'piece'

ovmf

is now failing build

here's the GCC10+ovmf build log

  https://paste.opensuse.org/949a8539

before spinning my wheels, is ovmf -- related to qemu here -- known to build with GCC10? i.e., is 'my' buildfail GCC10 related?
Comment 11 Bruce Rogers 2020-05-14 02:28:15 UTC
(In reply to pgnd _ from comment #10)
> I build qemu @
> 
>   https://build.opensuse.org/project/show/home:pgnd:Virtualization:qemu
> 
> gcc9 has been working great.
> 
> after this bug's 'close', 
> 
> I switched my obs qemu build over to GCC 10.  One 'piece'
> 
> ovmf
> 
> is now failing build
> 
> here's the GCC10+ovmf build log
> 
>   https://paste.opensuse.org/949a8539
> 
> before spinning my wheels, is ovmf -- related to qemu here -- known to build
> with GCC10? i.e., is 'my' buildfail GCC10 related?

Although the qemu package can be enabled to build the EDK2 ovmf code, it doesn't by default so I'm not aware of how it behaves with gcc10. Gary Lin is in charge of ovmf, so I'll add him to cc list.
Comment 12 pgnd _ 2020-05-14 04:05:02 UTC
thx.

so far, all I can additionally verify is that switching BACK to gcc9 cures the failed-build problem;

i.e., gcc9 build's OK == "succeeded". status here:

 https://build.opensuse.org/project/show/home:pgnd:Virtualization:qemu

i understand that's a different statement than gcc10 _is_ the problem.

poking around upstream & on gcc list(s) to see if i can find anything relevant ... before someone here provides any additional/useful insight.


let me know if this^ should be moved to a separate bug.  i s'pose Gary Lin may have some comment re: that.
Comment 13 Gary Ching-Pang Lin 2020-05-14 05:05:02 UTC
(In reply to pgnd _ from comment #12)
> thx.
> 
> so far, all I can additionally verify is that switching BACK to gcc9 cures
> the failed-build problem;
> 
> i.e., gcc9 build's OK == "succeeded". status here:
> 
>  https://build.opensuse.org/project/show/home:pgnd:Virtualization:qemu
> 
> i understand that's a different statement than gcc10 _is_ the problem.
> 
> poking around upstream & on gcc list(s) to see if i can find anything
> relevant ... before someone here provides any additional/useful insight.
> 
> 
> let me know if this^ should be moved to a separate bug.  i s'pose Gary Lin
> may have some comment re: that.

Please file a separate bug since ovmf is currently not built from qemu.

After checking the build log, I found it failed at cross-compiling the firmware for AArch64. On the other hand, the build for x86_64 is fine. Hope this could narrow down the scope.